(*)___________________________________________________________________

  Project:

      MediaTag
      ________

      (C) 2004 Maxim Proskurnya,
               max@axofiber.org.ru

  Component:  MainForm
  Comments :  Utility for music (mp3, flac) archive renaming and
              tagging.
  ____________________________________________________________________

  26.XI.2004                                                     00.02
    Less UI improvements
  17.XI.2004                                                     00.01
    Added XP Theme Manager component
  03.XI.2004                                                     00.00
   ___________________________________________________________________
(*)

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus, ClipBrd, id3, fLaCParserUnit,
  ThemeMgr;

type

  TFileTag = ( ftTITLE, ftVERSION, ftALBUM, ftTRACKNUMBER, ftARTIST, ftPERFORMER,
               ftCOPYRIGHT, ftLICENSE, ftORGANIZATION, ftDESCRIPTION,
               ftGENRE, ftDATE, ftLOCATION, ftCONTACT,
               ftSAMPLERATE, ftCHANNELS, ftBPS, ftTIMEDURATION, ftBITRATE );


  TMediaTagForm = class(TForm)
    OpenDlg: TOpenDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    AddFilesMenu: TMenuItem;
    RemoveFileMenu: TMenuItem;
    ClearFilesMenu: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    RenameFilesMenu: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    WriteTags: TMenuItem;
    N13: TMenuItem;
    ReadTagsAgain: TMenuItem;
    CopyNamesToBufferMenu: TMenuItem;
    N16: TMenuItem;
    PasteNamesToBufferMenu: TMenuItem;
    N15: TMenuItem;
    N17: TMenuItem;
    Panel1: TPanel;
    Splitter1: TSplitter;
    GroupBox2: TGroupBox;
    FileList: TListView;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    AttributeList: TListView;
    TabSheet2: TTabSheet;
    SchemaList: TListView;
    DelimiterED: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Label3: TLabel;
    Bevel4: TBevel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    BitsPerSample: TLabel;
    AudioChannelsQnt: TLabel;
    Label8: TLabel;
    SampleRateLabel: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    TracksQnt: TLabel;
    StatusBar: TStatusBar;
    Label6: TLabel;
    FormatName: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    BitRateLabel: TLabel;
    Label11: TLabel;
    TimeDurationLabel: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    GenresCB: TComboBox;
    ThemeManager1: TThemeManager;
    N2: TMenuItem;
    procedure AddFilesBtnClick(Sender: TObject);
    procedure ClearFilesBtnClick(Sender: TObject);
    procedure RemoveFileBtnClick(Sender: TObject);
    procedure UpdateTrackNumbers;
    procedure FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure FileListDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure AttributeListEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure FileListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure FileListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure AttributeListExit(Sender: TObject);
    procedure CopyNamesToBufferMenuClick(Sender: TObject);
    procedure PasteNamesToBufferMenuClick(Sender: TObject);
    procedure RenameFilesMenuClick(Sender: TObject);
    procedure SchemaListStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure SchemaListDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure FileListStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure FormCreate(Sender: TObject);
    procedure SchemaListEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure N6Click(Sender: TObject);
    procedure WriteTagsClick(Sender: TObject);
    procedure ReadTagsAgainClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AttributeListKeyPress(Sender: TObject; var Key: Char);
    procedure ShowStatus ( Mes: string );
    function  TagInt ( T: TFileTag ): Integer;
    procedure AttributeListClick(Sender: TObject);
    procedure GenresCBExit(Sender: TObject);
    procedure GenresCBKeyPress(Sender: TObject; var Key: Char);
    procedure N2Click(Sender: TObject);
    procedure SchemaListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure FileListDeletion(Sender: TObject; Item: TListItem);
  private
    { Private declarations }
    BeginFileListUpdate : Boolean;
    BeginSchemaUpdate   : Boolean;
    CurrentDir          : string;
    ID3Parser           : TID3Parser;
    fLaCParser          : TfLaCParser;
    procedure CheckOutSchemaList;
    procedure ReadTags ( FileName: string; Item: TListItem );
  public
    { Public declarations }
  end;

var
  MediaTagForm: TMediaTagForm;

implementation

{$R *.DFM}

uses
  AboutForm, ShellApi;


procedure TMediaTagForm.FormCreate(Sender: TObject);
var
  i, n : Integer;
  Item : TListItem;
  NamingSchema : array of integer;
begin
  BeginFileListUpdate := False;
  BeginSchemaUpdate   := False;
  CurrentDir          := GetCurrentDir;
  ID3Parser           := TID3Parser.Create;
  fLaCParser          := TfLaCParser.Create;

  // Init tabs
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( ' ()' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( '' );
  AttributeList.Items.Add.SubItems.Add ( ' ()' );
  AttributeList.Items.Add.SubItems.Add ( '(C)  ' );
  AttributeList.Items.Add.SubItems.Add ( '' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( '' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );
  AttributeList.Items.Add.SubItems.Add ( ' ' );

  n := 5;
  SetLength ( NamingSchema, n );
  NamingSchema[0] := 4;
  NamingSchema[1] := 2;
  NamingSchema[2] := 11;
  NamingSchema[3] := 3;
  NamingSchema[4] := 0;

  for i := 0 to n - 1 do
  begin
    Item := SchemaList.Items.Add ();
    Item.Caption := AttributeList.Items[NamingSchema[i]].SubItems[0];
    Item.SubItems.Add ( IntToStr ( NamingSchema[i] ) );
  end;

  // Init genres;
  GenresCB.Items.Clear;
  for i := 0 to 125 do
    GenresCB.Items.Add ( Genres[i] );
end;



procedure TMediaTagForm.AddFilesBtnClick(Sender: TObject);
var
  i    : Integer;
  Item : TListItem;
  s    : string;

  procedure AddFile ( Name: string );
  var
    j  : Integer;
  begin
    Item := FileList.Items.Add;
    s := ExtractFileName ( Name );
    s := Copy ( s, 1, Length ( s ) - Length ( ExtractFileExt ( s ) ) );
    Item.SubItems.Add ( s );
    Item.SubItems.Add ( Name );
    Item.SubItems.Add ( s );
    for j := 1 to ord ( ftBITRATE )  do
      Item.SubItems.Add ( '' );
    ReadTags ( Name, Item );
  end;

begin
  OpenDlg.Title := 'MediaTag |    ';
  if OpenDlg.Execute then
  begin
    FileList.Items.BeginUpdate;
    if 0 < OpenDlg.Files.Count then
    begin
      for i := 1 to OpenDlg.Files.Count - 1 do
        AddFile ( OpenDlg.Files[i] );
      AddFile ( OpenDlg.Files[0] );
    end;
    ClearFilesMenu.Enabled := True;
    WriteTags.Enabled      := True;
    ReadTagsAgain.Enabled  := True;
    CopyNamesToBufferMenu.Enabled  := True;
    PasteNamesToBufferMenu.Enabled := True;
    UpdateTrackNumbers;
    FileList.Items.EndUpdate;
  end;
  ShowStatus ( ' : ' + IntToStr ( OpenDlg.Files.Count ) + '.' );
end;



procedure TMediaTagForm.CheckOutSchemaList;
var
  i : Integer;
begin
  for i := 0 to SchemaList.Items.Count - 1 do
    SchemaList.Items[i].Checked := False;
end;



procedure TMediaTagForm.ClearFilesBtnClick(Sender: TObject);
begin
  if Application.MessageBox ( '     .' + #13#10 + #13#10 + '  ?', PCHar ( '!' ), MB_YESNO ) = IDYES then
  begin
    FileList.Items.Clear;
    ClearFilesMenu.Enabled := False;
    CheckOutSchemaList;
    TracksQnt.Caption := '0';
    ShowStatus ( '   .' );
  end;
end;



procedure TMediaTagForm.RemoveFileBtnClick(Sender: TObject);
var
  i : Integer;
begin
  if 0 < FileList.SelCount then
  begin
    FileList.Items.BeginUpdate;

    for i := FileList.Items.Count - 1 downto 0 do
    begin
      if FileList.Items[i].Selected then
      begin
        ShowStatus ( ' "' + ExtractFileName ( FileList.Items[i].Subitems[1] ) + '"   .' );
        FileList.Items.Delete ( i );
      end
    end;
    TracksQnt.Caption := IntToStr ( FileList.Items.Count )  + ' ';
    FileList.Items.EndUpdate;
  end;
end;



function LeadingZero ( var Number: string ): string;
begin
  if Length ( Number ) = 1 then
    Result := '0' + Number
  else
    Result := Number;
end;



procedure TMediaTagForm.UpdateTrackNumbers;
var
  i : Integer;
  s : string;
begin
  FileList.Items.BeginUpdate;

  for i := 0 to FileList.Items.Count - 1 do
  begin
    s := IntToStr ( i + 1 );
    s := LeadingZero ( s );
    FileList.Items[i].Caption := s;
    if AttributeList.Items[3].Checked then
      FileList.Items[i].SubItems[5] := s;
  end;

  FileList.Items.EndUpdate;
end;



procedure TMediaTagForm.FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
var
  Item: TListItem;
begin
  if FileList.Selected <> nil then
  begin
    Item := FileList.GetItemAt ( X, Y );
    if Item <> nil then
    begin
      FileList.Items.Insert ( Item.Index ).Assign ( FileList.Selected );
      FileList.Items.Delete ( FileList.Selected.Index );
      UpdateTrackNumbers
    end
    else
    begin
      FileList.Items.Add ().Assign ( FileList.Selected );
      FileList.Items.Delete ( FileList.Selected.Index );
      UpdateTrackNumbers
    end;
  end;
  BeginFileListUpdate := False;
end;



procedure TMediaTagForm.FileListDragOver ( Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean );
begin
  Accept := BeginFileListUpdate;
end;



procedure TMediaTagForm.AttributeListEdited ( Sender: TObject; Item: TListItem; var S: String);
begin
  if Item.Index = 0 then
    FileList.Selected.SubItems[0] := s
  else if Item.Index = 3 then
    // Flag off if track number is edited
    Item.Checked := False;
  FileList.Selected.SubItems[Item.Index+2] := s;
end;



procedure TMediaTagForm.FileListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
var
  i : Integer;
begin
  // Load attributes
  AttributeList.Items.BeginUpdate;
  for i := 0 to AttributeList.Items.Count - 1 do
  begin
    AttributeList.Items[i].Caption := Item.SubItems[i+2];
  end;
  AttributeList.Items.EndUpdate;
  SampleRateLabel.Caption  := Item.SubItems[ TagInt ( ftSampleRate ) ];
  AudioChannelsQnt.Caption := Item.SubItems[ TagInt ( ftChannels ) ];
  BitsPerSample.Caption    := Item.SubItems[ TagInt ( ftBPS ) ];
  TimeDurationLabel.Caption:= Item.SubItems[ TagInt ( ftTimeDuration ) ];
  BitRateLabel.Caption     := Item.SubItems[ TagInt ( ftBitRate ) ];
end;



procedure TMediaTagForm.FileListChange ( Sender: TObject; Item: TListItem; Change: TItemChange );
begin
  if FileList.Selected = nil then
  begin
    AttributeList.Enabled := False;
    RemoveFileMenu.Enabled := False;
  end
  else
  begin
    AttributeList.Enabled := True;
    RemoveFileMenu.Enabled := True;
  end;
  TracksQnt.Caption := IntToStr ( FileList.Items.Count ) + ' ';
end;




procedure TMediaTagForm.FileListDeletion(Sender: TObject; Item: TListItem);
begin
  if FileList.Items.Count = 1 then
  begin
    ClearFilesMenu.Enabled := False;
    WriteTags.Enabled      := False;
    ReadTagsAgain.Enabled  := False;
    CopyNamesToBufferMenu.Enabled  := False;
    PasteNamesToBufferMenu.Enabled := False;
    CheckOutSchemaList;
  end
end;



procedure TMediaTagForm.AttributeListExit(Sender: TObject);
var
  i, j : Integer;
  Item : TListItem;
begin
  FileList.Items.BeginUpdate;
  for i := 0 to 11 do
  begin
    if AttributeList.Items[i].Checked then
    begin
      for j := 0 to FileList.Items.Count - 1 do
      begin
        Item := FileList.Items[j];
        if i = 3 then
        begin
          // Track number
          if j < 9 then
            Item.SubItems[i+2] := '0' + IntToStr ( j + 1 )
          else
            Item.SubItems[i+2] := IntToStr ( j + 1 );
        end
        else
          Item.SubItems[i+2] := AttributeList.Items[i].Caption;
      end;
    end;
  end;
  FileList.Items.EndUpdate;
end;



procedure TMediaTagForm.CopyNamesToBufferMenuClick(Sender: TObject);
var
  i : Integer;
  s : string;
begin
  for i := 0 to FileList.Items.Count - 1 do
    s := s + FileList.Items[i].SubItems[0] + #13#10;
  Clipboard.SetTextBuf ( PChar (s) );
  ShowStatus ( ' .' );
end;



procedure TMediaTagForm.PasteNamesToBufferMenuClick(Sender: TObject);
var
  s, t    : string;
  i, j, n : integer;
begin
  SetLength ( s, 2048 );
  n := Clipboard.GetTextBuf ( PChar (s), 2048 );
  if 0 < n then
  begin
    SetLength ( s, n );
    if Application.MessageBox ( PChar ( '         .' + #13#10 +
                                '    : ' + #13#10 + '________________' + #13#10#13#10 +
                                Copy  ( s, 1, 100 ) + '...' + #13#10 + '________________' + #13#10#13#10 + '  ?' ),
                                PChar ( '!' ), MB_YESNO ) = IDYES then
    begin
      SetLength ( s, 2048 );
      n := Clipboard.GetTextBuf ( PChar (s), 2048 );
      j := 0;
      for i := 0 to n do
      begin
        if FileList.Items.Count <= j then
          Break;
        if #30 < s[i] then
          t := t + s[i]
        else
          if t <> '' then
          begin
            FileList.Items[j].SubItems[0] := t;
            FileList.Items[j].SubItems[2] := t;
            t := '';
            j := j + 1;
          end;
      end;
    end;
  end;    
end;



procedure TMediaTagForm.RenameFilesMenuClick(Sender: TObject);
var
  i, j, k : Integer;
  Delimiter, Name, oldFileName : string;
begin
  Delimiter := DelimiterED.Text;

  for i := 0 to FileList.Items.Count - 1 do
  begin
    Name := '';
    for j := 0 to SchemaList.Items.Count - 1 do
    begin
      if SchemaList.Items[j].Checked then
      begin
        k := StrToInt ( SchemaList.Items[j].SubItems[0] ) + 2;
        if Length ( Name ) = 0 then
          Name := FileList.Items[i].SubItems[k]
        else
          Name := Name + Delimiter + FileList.Items[i].SubItems[k];
      end;
    end;

    oldFileName := FileList.Items[i].SubItems[1];
    if ( Name <> '' ) and
       ( Name <> oldFileName ) and
       ( FileExists ( oldFileName ) ) then
    begin
      Name := ExtractFilePath ( oldFileName ) + Name + ExtractFileExt ( oldFileName );
      if FileExists ( Name ) then
      begin
        if Application.MessageBox ( PChar ( '      ' + #13 + #10 + '"' + Name + '".' +
                                             #13 + #10 +
                                             #13 + #10 + '  ?' ), PCHar ( '!' ), MB_YESNO ) = ID_YES then
          DeleteFile ( Name )
        else
          Continue;
      end;
      RenameFile ( oldFileName, Name );
      FileList.Items[i].SubItems[0] := FileList.Items[i].SubItems[2];
      FileList.Items[i].SubItems[1] := Name;
    end;
  end;
end;



procedure TMediaTagForm.SchemaListStartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  BeginSchemaUpdate := True;
end;

procedure TMediaTagForm.SchemaListDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := BeginSchemaUpdate;
end;

procedure TMediaTagForm.FileListStartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  BeginFileListUpdate := True;
end;



procedure TMediaTagForm.SchemaListEndDrag(Sender, Target: TObject; X, Y: Integer);
var
  Item: TListItem;
begin
  if SchemaList.Selected <> nil then
  begin
    Item := SchemaList.GetItemAt ( X, Y );
    if Item <> nil then
    begin
      SchemaList.Items.Insert ( Item.Index ).Assign ( SchemaList.Selected );
      SchemaList.Items.Delete ( SchemaList.Selected.Index );
    end
    else
    begin
      SchemaList.Items.Add ().Assign ( SchemaList.Selected );
      SchemaList.Items.Delete ( SchemaList.Selected.Index );
    end;
  end;
  BeginSchemaUpdate := False;
end;



procedure TMediaTagForm.N6Click(Sender: TObject);
begin
  Close;
end;



procedure TMediaTagForm.ReadTagsAgainClick(Sender: TObject);
begin
  ReadTags ( FileList.Selected.SubItems[1], FileList.Selected );
end;



procedure TMediaTagForm.ReadTags ( FileName: string; Item: TListItem );
var
  ID3FileStatus : TID3FileStatus;
  Extension: string;
  Index    : Integer;
  SampleRate, Channels, BPS : Integer;
  Duration : Integer;
  TotalSamplesQnt, MediaFileSize : Int64;
  TagName, TagValue : string;
  Comments : TStringList;
  Title, Artist, Album, Year, Comment, TrackNumber, Genre : string;

  function ConvertBitRate ( MediaFileSize, SampleRate, TotalSamplesQnt: Int64 ): string;
  begin
    Result := IntToStr ( MediaFileSize * SampleRate div TotalSamplesQnt * 8 shr 10 );
  end;

begin
  Extension := LowerCase ( ExtractFileExt ( FileName ) );
  if Extension = '.mp3' then
  begin
    ID3Parser.CheckFile ( FileName, ID3FileStatus );
    if ID3FileStatus = ifsID3v1 then
    begin
      id3Parser.ReadID3v1Attributes ( FileName, Title, Artist, Album, Year, Comment, TrackNumber, Genre );
      Item.SubItems[ TagInt ( ftTitle ) ]       := Title;
      Item.SubItems[ TagInt ( ftVersion ) ]     := '';
      Item.SubItems[ TagInt ( ftAlbum ) ]       := Album;
      Item.SubItems[ TagInt ( ftTrackNumber ) ] := LeadingZero ( TrackNumber );
      Item.SubItems[ TagInt ( ftArtist ) ]      := Artist;
      Item.SubItems[ TagInt ( ftGenre ) ]       := Genre;
      Item.SubItems[ TagInt ( ftDescription ) ] := Comment;
      Item.SubItems[ TagInt ( ftDate ) ]        := Year;
    end;
  end
  else
  if Extension = '.flac' then
  begin
    Comments := TStringList.Create;
    fLaCParser.ReadTags ( FileName, SampleRate, Channels, BPS, TotalSamplesQnt, MediaFileSize, Comments );
    for Index := 0 to Comments.Count - 1 do
    begin
      TagName  := Comments.Names[ Index ];
      TagValue := Comments.Values[ TagName ];
// ( - " ")
//Эй, моряк
      if TagName = 'TITLE'       then Item.SubItems[ TagInt ( ftTitle ) ]       := TagValue;
      if TagName = 'VERSION'     then Item.SubItems[ TagInt ( ftVersion ) ]     := TagValue;
      if TagName = 'ALBUM'       then Item.SubItems[ TagInt ( ftAlbum ) ]       := TagValue;
      if TagName = 'TRACKNUMBER' then Item.SubItems[ TagInt ( ftTrackNumber ) ] := LeadingZero ( TrackNumber );
      if TagName = 'ARTIST'      then Item.SubItems[ TagInt ( ftArtist ) ]      := TagValue;
      if TagName = 'PERFORMER'   then Item.SubItems[ TagInt ( ftPERFORMER ) ]   := TagValue;
      if TagName = 'COPYRIGHT'   then Item.SubItems[ TagInt ( ftCOPYRIGHT ) ]   := TagValue;
      if TagName = 'LICENSE'     then Item.SubItems[ TagInt ( ftLICENSE ) ]     := TagValue;
      if TagName = 'ORGANIZATION'then Item.SubItems[ TagInt ( ftORGANIZATION ) ]:= TagValue;
      if TagName = 'DESCRIPTION' then Item.SubItems[ TagInt ( ftDESCRIPTION ) ] := TagValue;
      if TagName = 'GENRE'       then Item.SubItems[ TagInt ( ftGenre ) ]       := TagValue;
      if TagName = 'DATE'        then Item.SubItems[ TagInt ( ftDate ) ]        := TagValue;
      if TagName = 'LOCATION'    then Item.SubItems[ TagInt ( ftLOCATION ) ]    := TagValue;
      if TagName = 'CONTACT'     then Item.SubItems[ TagInt ( ftCONTACT ) ]     := TagValue;
    end;
    Comments.Free;
    Item.SubItems[ TagInt ( ftSampleRate ) ]   := IntToStr ( SampleRate );
    Item.SubItems[ TagInt ( ftChannels ) ]     := IntToStr ( Channels );
    Item.SubItems[ TagInt ( ftBPS ) ]          := IntToStr ( BPS );
    Duration := TotalSamplesQnt div SampleRate;
    Item.SubItems[ TagInt ( ftTimeDuration ) ] := IntToStr ( Duration div 60 ) + ':' + IntToStr ( Duration mod 60 );
    Item.SubItems[ TagInt ( ftBitRate ) ]      := ConvertBitRate ( MediaFileSize, SampleRate, TotalSamplesQnt );
  end;
end;



procedure TMediaTagForm.WriteTagsClick(Sender: TObject);
var
  i : Integer;
  FileName    : string;
  Extension   : string;
  Comments    : TStringList;
  SampleRate, Channels, BPS: Integer;
  TotalSamplesQnt, MediaFileSize: Int64;
begin
  for i := 0 to FileList.Items.Count - 1 do
  begin
    FileName := FileList.Items[i].SubItems[1];
    Extension := LowerCase ( ExtractFileExt ( FileName ) );

    if Extension = '.mp3' then
    begin
      id3Parser.WriteID3v1Attributes ( FileName, FileList.Items[i].SubItems[ TagInt ( ftTitle ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftArtist ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftAlbum ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftDate ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftDescription ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftTrackNumber ) ],
                                             FileList.Items[i].SubItems[ TagInt ( ftGenre ) ] );
    end
    else
    if Extension = '.flac' then
    begin
      Comments := TStringList.Create;
      fLaCParser.ReadTags ( FileName, SampleRate, Channels, BPS, TotalSamplesQnt, MediaFileSize, Comments );
      Comments.Values['TITLE']       := FileList.Items[i].SubItems[ TagInt ( ftTitle ) ];
      Comments.Values['VERSION']     := FileList.Items[i].SubItems[ TagInt ( ftVERSION ) ];
      Comments.Values['ALBUM']       := FileList.Items[i].SubItems[ TagInt ( ftALBUM ) ];
      Comments.Values['TRACKNUMBER'] := FileList.Items[i].SubItems[ TagInt ( ftTRACKNUMBER ) ];
      Comments.Values['ARTIST']      := FileList.Items[i].SubItems[ TagInt ( ftARTIST ) ];
      Comments.Values['PERFORMER']   := FileList.Items[i].SubItems[ TagInt ( ftPERFORMER ) ];
      Comments.Values['COPYRIGHT']   := FileList.Items[i].SubItems[ TagInt ( ftCOPYRIGHT ) ];
      Comments.Values['LICENSE']     := FileList.Items[i].SubItems[ TagInt ( ftLICENSE ) ];
      Comments.Values['ORGANIZATION']:= FileList.Items[i].SubItems[ TagInt ( ftORGANIZATION ) ];
      Comments.Values['DESCRIPTION'] := FileList.Items[i].SubItems[ TagInt ( ftDESCRIPTION ) ];
      Comments.Values['GENRE']       := FileList.Items[i].SubItems[ TagInt ( ftGENRE ) ];
      Comments.Values['DATE']        := FileList.Items[i].SubItems[ TagInt ( ftDATE ) ];
      Comments.Values['LOCATION']    := FileList.Items[i].SubItems[ TagInt ( ftLOCATION ) ];
      Comments.Values['CONTACT']     := FileList.Items[i].SubItems[ TagInt ( ftCONTACT ) ];
      fLaCParser.WriteTags ( FileName, Comments );
      Comments.Free;
    end;
  end;
end;



procedure TMediaTagForm.FormDestroy(Sender: TObject);
begin
  fLaCParser.Free;
  ID3Parser.Free;
end;



procedure TMediaTagForm.ShowStatus ( Mes: string );
begin
  StatusBar.Panels[0].Text := Mes;
end;



procedure TMediaTagForm.AttributeListKeyPress ( Sender: TObject; var Key: Char );
begin
  if ( AttributeList.Selected <> nil ) and ( AttributeList.Selected.Index < 11 ) then
  begin
    if not AttributeList.IsEditing then
      AttributeList.Selected.EditCaption;
  end;
end;

function TMediaTagForm.TagInt ( T: TFileTag ): Integer;
begin
  TagInt := ord ( T ) + 2;
end;



procedure TMediaTagForm.AttributeListClick ( Sender: TObject );
begin
  if ( AttributeList.Selected <> nil ) and
     ( AttributeList.Selected.Index = 10 ) then
  begin
    GenresCB.Left := AttributeList.Selected.Left + AttributeList.Left - 2;
    GenresCB.Top  := AttributeList.Selected.Top + AttributeList.Top + 1;
    GenresCB.Width   := AttributeList.Columns[0].Width - 18;
    GenresCB.Visible := True;
    GenresCB.Text    := AttributeList.Selected.Caption;
  end
  else if GenresCB.Visible then
    GenresCBExit ( Sender );
end;



procedure TMediaTagForm.GenresCBExit(Sender: TObject);
begin
  AttributeList.Items[10].Caption := GenresCB.Text;
  FileList.Selected.SubItems[12]  := GenresCB.Text;
  GenresCB.Visible := False;
end;



procedure TMediaTagForm.GenresCBKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    GenresCBExit ( Sender );
  end;
end;

procedure TMediaTagForm.N2Click(Sender: TObject);
var
  About: TAboutForm;
begin
  About := TAboutForm.Create ( self );
  About.ShowModal;
end;



procedure TMediaTagForm.SchemaListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
var
  i : Integer;
  CanRename : Boolean;
begin
  CanRename := False;
  for i := 0 to SchemaList.Items.Count - 1 do
    if SchemaList.Items[i].Checked then CanRename := True;
  if RenameFilesMenu.Enabled <> CanRename then
    RenameFilesMenu.Enabled := CanRename;
end;


end.
